#!/usr/local/bin/ruby -Ks

# }CXC[pm ver.2.0
#  calcprob.rb: mvZRA
# Copyright 2007 again@T
#  http://nijzero.dw.land.to/

$debug = false if $debug == nil

class ProbabilityCalculator
  def initialize(cells, rest, log)
    @cells = cells
    @rest = rest
    @log = log
    
    #flag̍Ē`
    ignoreflag
    
    CellHolder.replace_mine1(@cells)
    @rest -= @cells.inject(0){|result,line| result + line.find_all{|cell| cell=="f"}.length }
    holder = nil
    nextlen = 0
    
    loop do
      holder = CellHolder.new(@cells, @rest, @log)
      nextlen = holder.define_next_to_number
      holder.split_next_to_number
      mines = holder.find_mine2
      break if mines.empty?
      mines.each do |pos|
        @cells[pos[0]][pos[1]] = "f"
      end
      @rest -= mines.length
    end
    
    @log.dump(stre = "rest:#{@rest}")
    @log.store(stre)
    @cells.each do |line|
      @log.dump(stre = line.join(" "))
      @log.store(stre)
    end
    
    if @rest == 0
      @percents = @cells.collect{|line| line.collect{|cell| cell=="f" ? 100 : 0} }
      return nil
    end
    
    areasizes = holder.area_cell_sizes
    areasizes.each_index do |index|
      @log.dump(stre = "GA#{index}TCYF#{areasizes[index]}")
      @log.store(stre)
    end
    
    #vZ{
    nonnextlen = @cells.inject(0){|result, line| result + line.find_all{|cellvalue| cellvalue=="u"}.length } - nextlen
    @log.dump(stre = "אڐF#{nonnextlen}")
    @log.store(stre)
    begin
      pattern_summary = holder.find_pattern
    rescue => evar
      @log.dump(evar)
      raise evar
    end
    index = 0
    pattern_summary.each do |aggregation|
      @log.dump(stre = "GA#{index}F")
      @log.store(stre)
      aggregation.each do |minecount, pattern|
        @log.dump(stre = "#{minecount}: #{pattern.join(",")}")
        @log.store(stre)
      end
      index += 1
    end
    merged = holder.merge_pattern(pattern_summary)
    
    @log.dump(stre = "WvF")
    @log.store(stre)
    merged.each do |minecount, pattern|
      if minecount != 0
        @log.dump(stre = "#{minecount}: #{pattern.join(",")} [#{pattern.inject{|result, value| result+value} / minecount}]")
      else 
        @log.dump(stre = "#{minecount}: #{pattern.join(",")} [0]")
      end
      @log.store(stre)
    end
    
    putmines = merged.keys.sort
    remainmines = putmines.collect{|minecount| @rest-minecount}
    ratios = Math.combination_fraction(nonnextlen, remainmines)
    
    @log.dump(stre = "{F#{ratios.join(",")} = #{nonnextlen}C#{remainmines.join(",")}")
    @log.store(stre)
    rated_mine_patterns = []
    total_mine_patterns = 0
    putmines.zip(ratios) do |putmine, ratio|
      rated_mine_patterns.push(rated = merged[putmine].collect{|x|x*ratio})
      total_mine_patterns += putmine==0 ? 1 : rated.inject{|result,value| result + value} / putmine
    end
    final_mine_patterns = rated_mine_patterns.transpose.collect{|values| values.inject{|res,x| res+x} }
    nonnext_mines = nonnextlen==0 ? 0 : ( @rest*total_mine_patterns-final_mine_patterns.inject{|res,x|res+x} ).quo(nonnextlen).to_f
    
    prob_cells = holder.prob_cells
    
    @log.dump(stre = "Sp^[F#{total_mine_patterns}")
    @log.store(stre)
    @log.dump(stre = "אڈF#{nonnext_mines} (#{100*nonnext_mines/total_mine_patterns}%)")
    @log.store(stre)
    
    @percents = @cells.collect do |line|
      line.collect{|cell| cell.kind_of?(Integer) ? 0 : (cell == "f" ? 100 : 100*nonnext_mines/total_mine_patterns)}
    end
    prob_cells.zip(final_mine_patterns) do |cell, count|
      @percents[cell.x][cell.y] = pc = (100*count).quo(total_mine_patterns)
      @log.dump(stre = "#{cell}F#{count} (#{pc.round}%)")
      @log.store(stre)
    end
    @log.write("vZI")
  end
  
  def percents
    @percents
  end
  
  def ignoreflag
    @cells.each do |row|
      row.collect! do |cell|
        if cell == "f"
          @rest+=1
          cell = "u"
        else
          cell
        end
      end
    end
  end
  
end

class CellHolder
  Search = [[-1,-1],[-1,0],[-1,1],[0,-1],[0,1],[1,-1],[1,0],[1,1]]
  
  #nLv.1
  def self.replace_mine1(statusarray)
    rows = statusarray.length
    cols = statusarray[0].length
    statusarray.each_index do |rowindex|
      statusarray[rowindex].each_index do |colindex|
        if (cell = statusarray[rowindex][colindex]).kind_of?(Integer)
          undefcells = Search.find_all do |rel|
            if ((x=rowindex+rel[0])>=0)&&(x<rows)&&((y=colindex+rel[1])>=0)&&(y<cols)
              !statusarray[x][y].kind_of?(Integer)
            else
              false
            end
          end
          if undefcells.length == cell
            undefcells.each do |rel|
              statusarray[rowindex+rel[0]][colindex+rel[1]] = "f"
            end
          end
        end
      end
    end
  end
  
  def initialize(statusarray, rest, log)
    @log = log
    @rest = rest
    
    @cells = []
    statusarray.each_index do |rowindex|
      row = []
      statusarray[rowindex].each_index do |colindex|
        if (cell = statusarray[rowindex][colindex]).kind_of?(Integer)
          row.push(NumberCell.new(rowindex, colindex, cell))
        elsif cell == "f"
          row.push(FlagCell.new(rowindex, colindex))
        else
          row.push(UndefinedCell.new(rowindex, colindex))
        end
      end
      @cells.push(row)
    end
    
    rows = @cells.length
    cols = @cells[0].length
    @cells.each_index do |rowindex|
      @cells[rowindex].each_index do |colindex|
        if (cell=@cells[rowindex][colindex]).kind_of?(NumberCell)
          Search.each do |rel|
            if ((x=rowindex+rel[0])>=0)&&(x<rows)&&((y=colindex+rel[1])>=0)&&(y<cols)
              if !@cells[x][y].kind_of?(NumberCell)
                cell.add_next_cell(@cells[x][y])
              end
            end
          end
        elsif cell.kind_of?(UndefinedCell)
          Search.each do |rel|
            if ((x=rowindex+rel[0])>=0)&&(x<rows)&&((y=colindex+rel[1])>=0)&&(y<cols)
              if @cells[x][y].kind_of?(NumberCell)
                cell.add_next_cell(@cells[x][y])
              end
            end
          end
        end
      end
    end
  end
  
  #nLv.2@OFsplit_next_to_numberς
  def find_mine2
    result = []
    @area_num_cells.each do |areanumcells|
      0.upto(areanumcells.length-2) do |i|
        (i+1).upto(areanumcells.length-1) do |j|
          iundef = areanumcells[i].next_undef_cells
          jundef = areanumcells[j].next_undef_cells
          common = iundef & jundef
          if (iundef - common).empty? #ji
            k,l = i,j
            diffcells = jundef - iundef
          elsif (jundef - common).empty? #ij
            k,l = j,i
            diffcells = iundef - jundef
          else
            next
          end
          if ((areanumcells[l].value-areanumcells[l].known_mines) - (areanumcells[k].value-areanumcells[k].known_mines))==diffcells.length
            diffcells.each do |undefcell|
              result.push([undefcell.x, undefcell.y])
            end
          end
        end
      end
    end
    return result.uniq
  end
  
  #אڗ̈
  def define_next_to_number
    @next_number_undef = @cells.inject([]){|result, line| result.concat( line.find_all{|cell| (cell.kind_of?(UndefinedCell))&&(!cell.next_cells.empty?)} ) }
    return @next_number_undef.length
  end
  
  #אڗ̈̕
  def split_next_to_number
    @area_num_cells = []
    @next_number_undef.each do |undefcell|
      found = []
      @area_num_cells.delete_if do |num_cells|
        if (flag = !(undefcell.next_cells & num_cells).empty?)
          found.concat(num_cells)
        end
        flag
      end
      if found.empty?
        @area_num_cells.push(undefcell.next_cells)
      else
        @area_num_cells.push( found.concat(undefcell.next_cells).uniq )
      end
    end
    
    @areas = @area_num_cells.collect do |num_cells|
      Area.new( @next_number_undef.find_all{|undef_cell| !(undef_cell.next_cells & num_cells).empty?} )
    end
  end
  def area_cell_sizes
    @areas.collect{|area| area.cells.length}
  end
  
  #zup^[T
  def find_pattern
    raise "zup^[݂܂" if @areas.length == 0
    summary = []
    @areas.each_index do |areaindex|
      @log.write("GA#{areaindex}(x:#{@areas[areaindex].cellgroups.length})񋓊Jn...")
      foundpatterns = tree(areaindex)
      raise "zup^[݂܂" if foundpatterns.empty?
      @log.write("񋓏I (#{foundpatterns.length}p^[)") 
      summary.push(@areas[areaindex].summary_grouped_patterns(foundpatterns))
    end
    return summary
  end
  
  #T{
  def tree(areaindex)
    knownpatterns = [[]]
    start_time = prev_time = Time.now
    0.upto(@areas[areaindex].cellgroups.length-1) do |level|
      result = []
      knownpatterns.each do |pattern|
        pattern.each_index do |index|
          @areas[areaindex].cellgroups[index].assume(pattern[index])
        end
        legalcounts = @areas[areaindex].cellgroups[pattern.length].find_legal
        legalcounts.each do |newcount|
          result.push(pattern.clone.push(newcount))
        end
      end
      knownpatterns = result
      if Time.now - prev_time > 1
        passed = Time.now - start_time
        @log.write("o:#{passed}b x:#{level+1}/#{@areas[areaindex].cellgroups.length} p^[:#{knownpatterns.length}")
        sleep(0.005)
        prev_time = Time.now
      end
    end
    return knownpatterns
  end
  
  #p^[̃}[W
  def merge_pattern(area_summaries)
    merged = {0 => []}
    area_summaries.each do |area_summary|
      merged_new = {}
      merged.each do |maggr|
        mergedtotal, mergedarrange = maggr
        mergedpatterncount = mergedtotal==0 ? 1 : mergedarrange.inject(0){|result,value|result+value} / mergedtotal
        area_summary.each do |aggregation|
          totalmines, arrangepattern = aggregation
          patterncount = totalmines==0 ? 1 : arrangepattern.inject(0){|result,value|result+value} / totalmines
          newpattern = mergedarrange.collect{|x|x*patterncount}.concat( arrangepattern.collect{|x|x*mergedpatterncount} )
          newtotal = mergedtotal + totalmines
          if merged_new.key?(newtotal)
            merged_new[newtotal] = merged_new[newtotal].zip(newpattern).collect{|values| values[0]+values[1]}
          else
            merged_new[newtotal] = newpattern
          end
        end
      end
      merged = merged_new
    end
    #merged̈k
    counts = merged.collect do |aggr|
      aggr[0]==0 ? 0 : aggr[1].inject{|result, value| result+value} / aggr[0]
    end
    commongcd = merged.inject(0) do |result, aggr|
      Math.gcd( Math.multi_gcd(aggr[1]), result )
    end
    commongcd = Math.gcd( Math.multi_gcd(counts), commongcd )
    merged.each do |aggr|
      aggr[1].collect!{|x| x / commongcd}
    end if commongcd != 0
    return merged
  end
  
  def prob_cells
    undef_cells_new = []
    @areas.each do |area|
      undef_cells_new.concat(area.group_cells)
    end
    undef_cells_new
  end
end

class Area
  def initialize(cellarray)
    @cells = cellarray
    celldiv = []
    @cells.each do |cell|
      if (hitgroup = celldiv.find{|group| group[0].next_cells == cell.next_cells}) == nil
        celldiv.push([cell])
      else
        hitgroup.push(cell)
      end
    end
    @cellgroups = celldiv.collect{|arraycell| UndefCellGroup.new(arraycell) }
  end
  
  def summary_grouped_patterns(patterns)
    lengtharray = @cellgroups.collect{|group| group.length}
    arrangement = patterns.collect do |pattern|
      zipped = pattern.zip(lengtharray)
      prod = zipped.inject(1){|result, valset| result * Math.combination(valset[1], valset[0])}
      values = zipped.collect{|minecount, grouplength| prod * minecount / grouplength}
      expanded_values = []
      values.zip(lengtharray) do |value, length|
        length.times do
          expanded_values.push(value)
        end
      end
      arrangedmines = pattern.inject{|result, value| result + value}
      [arrangedmines, expanded_values]
    end
    aggregation = {}
    arrangement.each do |arr|
      minecount, values = arr
      if aggregation.key?(minecount)
        aggregation[minecount] = aggregation[minecount].zip(values).collect{|values| values[0]+values[1]}
      else
        aggregation[minecount] = values
      end
    end
    @cells_new = []
    @cellgroups.each do |group|
      @cells_new.concat(group.cells)
    end
    return aggregation
  end
  
  def group_cells
    @cells_new
  end
  def cells
    @cells
  end
  def cellgroups
    @cellgroups
  end
end

class UndefCellGroup
  def initialize(undef_cells)
    @cells = undef_cells
  end
  def assume(minecount)
    @cells.each_index do |index|
      if index < minecount
        @cells[index].status = UndefinedCell::MINE
      else
        @cells[index].status = UndefinedCell::EMPTY
      end
    end
  end
  def find_legal
    result = []
    assume(0)
    celllength = @cells.length
    0.upto(celllength) do |minecount|
      result.push(minecount) if check_legal
      @cells[minecount].status = UndefinedCell::MINE if minecount < celllength
    end
    return result
  end
  def check_legal
    @cells[0].check_legal
  end
  def cells
    @cells
  end
  def length
    @cells.length
  end
  def to_s
    "["+@cells.join("")+"]"
  end
end

class Cell
  def initialize(x,y)
    @x = x
    @y = y
  end
  def x
    @x
  end
  def y
    @y
  end
  def to_s
    "(#{@x},#{@y})"
  end
end

class NumberCell < Cell
  def initialize(x,y,num)
    @x = x
    @y = y
    @value = num
    @next_nonnumber_cells = []
  end
  def value
    @value
  end
  def add_next_cell(nextcell)
    @next_nonnumber_cells.push(nextcell)
  end
  def next_cells
    @next_nonnumber_cells
  end
  def next_undef_cells
    @next_nonnumber_cells.find_all{|cell| cell.kind_of?(UndefinedCell)}
  end
  def known_mines
    minecount = 0
    @next_nonnumber_cells.each do |umcell|
      minecount += 1 if umcell.status == UndefinedCell::MINE
    end
    return minecount
  end
  def check_legal
    minecount = undefcount = 0
    @next_nonnumber_cells.each do |umcell|
      if umcell.status == UndefinedCell::MINE
        minecount += 1
      elsif  umcell.status == UndefinedCell::UNDEFINED
        undefcount += 1
      end
    end
    return (minecount <= @value)&&(@value <= minecount + undefcount)
  end
end

class UndefinedCell < Cell
  UNDEFINED = -1
  EMPTY = 0
  MINE = 1
  def initialize(x,y)
    @x = x
    @y = y
    @status = UNDEFINED
    @next_number_cells = []
  end
  def add_next_cell(nextcell)
    @next_number_cells.push(nextcell)
  end
  def next_cells
    @next_number_cells
  end
  def status
    @status
  end
  def status=(newstatus)
    @status = newstatus
  end
  def check_legal
    @next_number_cells.all? {|numcell| numcell.check_legal}
  end
end

class FlagCell < Cell
  def status
    UndefinedCell::MINE
  end
end


module Math
  def self.multi_gcd(ints)
    ints.inject{|result, value| gcd(value, result)}
  end
  
  def self.gcd(a,b)
    a,b = b,a if a<b
    until b==0
      t = a%b
      return b if t==0
      a,b = b,t
    end
    return a
  end
  
  def self.combination(n,r)
    return 0 if (r > n)||(r < 0)
    return 1 if (r == n)||(r == 0)
    (n-r+1..n).inject{|result,value| result*value} / (1..r).inject{|result, value| result*value}
  end
  
  #gݍ킹̔
  #@@prod̂
  # nCr   nCr-1 nCr-2 nCr-3
  # n-r+1 r     r     r
  # n-r+2 n-r+2 r-1   r-1
  # n-r+3 n-r+3 n-r+3 r-2
  # ꂼ̗̐ς
  def self.combination_fraction(n,rarray)
    rlength = rarray.length
    
    prod = Array.new(rlength){|x| []}
    lkey = n-rarray[0]+1
    rkey = rarray[0]
    0.upto(rlength-2) do |prod_item_count|
      prod.each_index do |index|
        if index-prod_item_count>0
          prod[index] << rkey
        else
          prod[index] << lkey
        end
      end
      lkey += 1
      rkey -= 1
    end
    
    ans = prod.collect{|vector| vector.inject(1){|result, item| result * item } }
    gcdtmp = Math.multi_gcd(ans)
    ans.collect!{|val| val/gcdtmp}
    return ans
  end
end

class Numeric
  def to_s_2figures
    if (self > 100)||(self<0)
      raise "l͈͊Oł"
    end
    toi = self.round
    if toi < 10
      return "0"+toi.to_s
    elsif toi >= 100
      return "XX"
    else
      return toi.to_s
    end
  end
end
