#!/usr/local/bin/ruby -Ks

# }CXC[pm ver.2.0
#  cui.rb: CUIŎs
# Copyright 2007 again@T
#  http://nijzero.dw.land.to/

require 'jcode'
require 'yaml'

require 'screen'
require 'textreader'
require 'calcprob'

$debug = false if $debug == nil
#$debug =true

class Output
  def initialize(debug)
    @debug = debug
    @stored_text = ""
  end
  def write(str)
    Kernel.puts str
  end
  def dump(str)
    Kernel.puts str if @debug
  end
  def store(str)
    @stored_text += str + "\n"
  end
  def write_file(writeok)
    if writeok
      filename = Time.now.strftime("%Y-%m-%d_%H-%M-%S.txt")
      f = File.open(filename, "w")
      begin
        f.write(@stored_text)
      rescue
      ensure
        f.close
      end
    end
    @stored_text = ""
  end
end

output = Output.new($debug)
output.write("ǂݍ݃\[XH@1:}CXC[pʁ@2:eLXgt@C@0:I")
code = gets.to_i
if code == 1
  files = Dir.glob("*.yml").collect do |yamlfilename|
    {"filename" => yamlfilename, "name" => YAML.load_file(yamlfilename)["name"]}
  end
  if files.empty? 
    output.write "ʒ`t@C܂B"
    exit
  end
  output.write "ʃ^CvH"
  output.write "0: I"
  files.each_index do |index|
    output.write "#{index+1}: #{files[index]['name']}"
  end
  type = gets.to_i
  exit if !(1..files.length).include?(type)
  
  begin
    sio = ScreenIO.new(files[type-1]["filename"])
    sio.cell_values
    sio.rest_value
    data = sio
  rescue => evar
    output.write(evar.to_s)
    exit
  end
elsif code == 2
  output.write("t@CH")
  filename = gets.strip
  begin
    data = TextParser.new(filename)
  rescue => evar
    output.write evar
    exit
  end
else
  exit
end

data.cell.each do |line|
  output.write(line.join(" "))
end
output.dump("rows:#{data.rows}")
output.dump("cols:#{data.cols}")
output.write("rest:#{data.rest}")

begin
  pc = ProbabilityCalculator.new(data.cell, data.rest, output)
rescue => evar
  output.write(evar)
  output.store(evar.to_s)
  output.write_file(true)
  exit
end

pc.percents.each do |line|
  output.write(stre = line.collect{|val| val.to_s_2figures}.join(" "))
  output.store(stre)
end
output.write_file(true)

if code == 1
  sio.set_colors(pc.percents)
end
