#!/usr/local/bin/ruby -Ks

# }CXC[pm ver.2.0
#  screen.rb: }CXC[pʓǂݏ
# Copyright 2007 again@T
#  http://nijzero.dw.land.to/

require 'Win32API'
require 'yaml'

require 'sourcedata'

class ScreenIO
  MIN = 0
  LOW = 10
  MIDDLE = 20
  HIGH = 50
  MAX = 100
  COLOR = {MIN => [255,0,0], LOW => [255,255,0], MIDDLE => [0,255,0], HIGH => [0,255,255], MAX => [0,0,255]}
  
  include SourceData
  
  def initialize(yamlfilename)
    begin
      @screenrule = YAML.load_file(yamlfilename)
      @windowname = @screenrule["window"]
      @rest_top = @screenrule["rest"]["top"]
      @rest_left = @screenrule["rest"]["left"]
      @rest_width = @screenrule["rest"]["width"]
      @rest_figures = @screenrule["rest"]["figures"]
      @rest_rule = @screenrule["rest"]["rule"]
      @cell_top = @screenrule["cell"]["top"]
      @cell_left = @screenrule["cell"]["left"]
      @cell_bottom = @screenrule["cell"]["bottom"]
      @cell_right = @screenrule["cell"]["right"]
      @cell_size = @screenrule["cell"]["size"]
      @cell_fill_size = @screenrule["cell"]["fill"]
      @cell_rule = @screenrule["cell"]["rule"]
    rescue
      raise "YAMLt@C̓ǂݍ݂Ɏs܂"
    end
    @findWindow = Win32API.new('user32.dll', 'FindWindow', 'p p', 'i')
    @getClientRect = Win32API.new('user32.dll', 'GetClientRect', 'p p', 'v')
    @getDeviceContext = Win32API.new('user32.dll', 'GetDC', 'i', 'i')
    @releaseDeviceContext = Win32API.new('user32.dll', 'ReleaseDC', 'i i', 'v')
    @getPixel = Win32API.new('gdi32.dll', 'GetPixel', 'i i i', 'i')
    @fillRect = Win32API.new('user32.dll', 'FillRect', 'i p i', 'i')
    @createBrush = Win32API.new('gdi32.dll', 'CreateSolidBrush', 'i', 'i')
    @deleteObject = Win32API.new('gdi32.dll', 'DeleteObject', 'i', 'i')
    @cursorPos = Win32API.new('user32.dll', 'GetCursorPos', 'p', 'i')
    @screenToClient = Win32API.new('user32.dll', 'ScreenToClient', 'i p', 'i')
    
    @dc = 0
    @handleMine = 0
  end
  
  def cell_values
    raise "}CXC[p̃EChEFł܂B" if !open_device_context
    begin
      @cell = (0..@cellheight-1).collect{|y| (0..@cellwidth-1).collect{|x| apply_cell_rule(@cell_rule,x,y)}}
      raise "Q[IĂ܂B" if @cell.inject(0){|result,line| result + line.find_all{|value| (0..8).include?(value) || ["u","f"].include?(value)}.length } != @cellheight*@cellwidth
      return @cell
    rescue => evar
      raise evar
    ensure
      close_device_context
    end
  end
  def rest_value
    raise "}CXC[p̃EChEFł܂B" if !open_device_context
    begin
      figure_nums = (0..@rest_figures-1).collect{|fig| apply_rest_rule(@rest_rule, fig)}
      @rest = figure_nums.inject(0){|result, value| result*10+value}
    rescue => evar
      raise evar
    ensure
      close_device_context
    end
  end
  def set_colors(probs)
    usedprob = probs.inject([]){|result, line| result.concat(line).uniq}.uniq
    brushes_ary = []
    usedprob.each do |prob|
      brushes_ary << prob << @createBrush.call(prob_to_color(prob))
    end
    brushes = Hash[*brushes_ary]
    raise "}CXC[p̃EChEFł܂B" if !open_device_context
    begin
      raise "}CXC[p̃EChEFł܂B" if @dc == 0
      probs.each_index do |rowindex|
        probs[rowindex].each_index do |colindex|
          if ["u","f"].include?@cell[rowindex][colindex]
            endx = (colindex+1)*@cell_size+@cell_left
            endy = (rowindex+1)*@cell_size+@cell_top
            rect = [endx-@cell_fill_size,endy-@cell_fill_size,endx,endy].pack("l!4")
            @fillRect.call(@dc,rect,brushes[probs[rowindex][colindex]])
          end
        end
      end
    rescue => evar
      raise evar
    ensure
      close_device_context
      brushes.each{|key, brush| @deleteObject.call(brush)}
    end
  end
  def current_cell_pos
    raise "}CXC[p̃EChEFł܂B" if !open_device_context
    begin
      return nil if @handleMine == 0
      
      pointstruct = [1,2].pack("l!2")
      @cursorPos.call(pointstruct)
      
      @screenToClient.call(@handleMine, pointstruct)
      mouseleft, mousetop = pointstruct.unpack("l!2")
      return nil if (mouseleft<0)||(mousetop<0)
      
      x = (mouseleft-@cell_left)/@cell_size
      y = (mousetop-@cell_top)/@cell_size
      return nil if (x<0)||(y<0)||(x>=@cellwidth)||(y>=@cellheight)
      return [x,y]
    rescue => evar
      raise evar
    ensure
      close_device_context
    end
  end
  
  private
  
  def open_device_context
    @handleMine = @findWindow.call(nil,@windowname)
    return nil if @handleMine == 0
    rectStruct = [1,2,3,4].pack("l!4")
    @getClientRect.call(@handleMine, rectStruct)
    left, top, width, height = rectStruct.unpack("l!4")
    @cellwidth = (width-@cell_left-@cell_right)/@cell_size
    @cellheight = (height-@cell_top-@cell_bottom)/@cell_size
    return nil if (@cellwidth<0)||(@cellheight<0)
    @dc = @getDeviceContext.call(@handleMine)
  end
  def close_device_context
    @releaseDeviceContext.call(@handleMine, @dc) if (@dc != 0)&&(@handleMine != 0)
  end
  def apply_cell_rule(rule, x, y)
    raise "}CXC[p̃EChEFł܂B" if @dc == 0
    begin
      color = @getPixel.call(@dc, x*@cell_size+rule["coord"]["left"]+@cell_left, y*@cell_size+rule["coord"]["top"]+@cell_top)
      matched = rule["match"].find{|cond| cond["color"]==color}
      matched = rule["match"].find{|cond| cond["color"]==nil} if !matched
      value = matched["value"]
      return value if value
      return apply_cell_rule(matched["rule"], x, y)
    rescue => evar
      raise "Z̔FɎs܂B"
    end
  end
  def apply_rest_rule(rule, figure)
    raise "}CXC[p̃EChEFł܂B" if @dc == 0
    begin
      color = @getPixel.call(@dc, figure*@rest_width+rule["coord"]["left"]+@rest_left, rule["coord"]["top"]+@rest_top)
      matched = rule["match"].find{|cond| cond["color"]==color}
      matched = rule["match"].find{|cond| cond["color"]==nil} if !matched
      value = matched["value"]
      return value if value
      return apply_rest_rule(matched["rule"], figure)
    rescue => evar
      raise "cn̔FɎs܂B"
    end
  end
  def prob_to_color(prob)
    if prob < LOW
      higher, lower = LOW, MIN
    elsif prob < MIDDLE
      higher, lower = MIDDLE, LOW
    elsif prob < HIGH
      higher, lower = HIGH, MIDDLE
    else
      higher, lower = MAX, HIGH
    end
    rgb = 0
    (0..2).each do |index|
      rgb = (rgb<<8) | (COLOR[lower][index]*(higher-prob)/(higher-lower) + COLOR[higher][index]*(prob-lower)/(higher-lower)).round
    end
    return rgb
  end
end

__END__
#ȉeXgR[hB__END__RgAEgŎs

files = Dir.glob("*.yml").collect do |yamlfilename|
  {"filename" => yamlfilename, "name" => YAML.load_file(yamlfilename)["name"]}
end
puts "0: I"
files.each_index do |index|
  puts "#{index+1}: #{files[index]['name']}"
end
code = gets.to_i
exit if !(1..files.length).include?(code)

sio = ScreenIO.new(files[code-1]["filename"])
cells = sio.cell_values.each{|line| puts line.join(" ")}
puts sio.rest_value
sio.set_colors(cells.collect{|line| line.collect{|value| rand(100)} })
